//+------------------------------------------------------------------+
//|                                                          RSI.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Red
//---- input parameters
extern int RSIPeriod=14;
extern int Applied_price=0;
extern int Code=159;
//---- buffers
double RSIBuffer[];
double PointBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,RSIBuffer);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,Code);
   SetIndexBuffer(1,PointBuffer);
   SetIndexEmptyValue(1,0.0);
//---- name for DataWindow and indicator subwindow label
   short_name="RSI("+RSIPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   SetIndexLabel(1,short_name);
//----
   SetIndexDrawBegin(0,RSIPeriod);
   SetIndexDrawBegin(1,RSIPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Relative Strength Index                                          |
//+------------------------------------------------------------------+
int start()
  {
   int i, limit, counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
//----
   if(counted_bars<1) limit=Bars-1;
   else limit=Bars-counted_bars;
//----
   for(i=limit; i>=0; i--)
    {
     RSIBuffer[i]=iRSI(NULL, 0, RSIPeriod, Applied_price, i);
     PointBuffer[i]=iRSI(NULL, 0, RSIPeriod, Applied_price, i);
    }  
//----
   return(0);
  }
//+------------------------------------------------------------------+